import * as _vuepress_core from '@vuepress/core';
import { Plugin } from '@vuepress/core';
import { DocgenCLIConfig } from 'vue-docgen-cli/lib/config';
import { ComponentDoc } from 'vue-docgen-api';
import { GrayMatterOption } from 'gray-matter';

declare module '@vuepress/core' {
    interface PageOptions {
        isDocgenPage?: boolean;
    }
}
interface VueDocgenPluginPages {
    root?: string;
    components: string | string[];
    outDir?: string;
}
interface VueDocgenPluginOptions {
    docgenCliConfig?: Partial<Omit<DocgenCLIConfig, 'outDir' | 'components'>>;
    docgenCliConfigPath?: string;
    pages?: string | string[] | VueDocgenPluginPages[];
}

declare const VueDocgenPlugin: ({ docgenCliConfig, docgenCliConfigPath, pages, }: VueDocgenPluginOptions) => Plugin<_vuepress_core.PluginObject>;

declare const extractAndCutFrontmatter: (doc: Partial<Pick<ComponentDoc, 'docsBlocks'>>, grayMatterOptions: GrayMatterOption<any, any>, content?: string) => {
    content: string;
    frontmatter: Record<any, any>;
};

export { VueDocgenPlugin, VueDocgenPluginOptions, VueDocgenPluginPages, extractAndCutFrontmatter };
